#include <stdio.h>
#include <string.h>
#include <windows.h>

#define DEFAULTCOMMAND      "--alt-preset standard"

void usage ()
{
    fprintf ( stderr, "x3enc <infile> [outfile]\n" );
    fprintf ( stderr, "encodes with LAME using --alt-preset standard\n" );
}

int main ( int argc, char** argv )
{
    char    lameopt [1024];
    char    param   [1024];
    char    drive   [260];
    char    dir     [260];
    char    fname   [260];
    char    path    [260];
    char*   infile  = NULL;
    char*   outfile = NULL;
    int i;

    if ( argc < 2 ) {
        usage ();
        return 0;
    }

    _splitpath ( argv[0], drive, dir, fname, NULL );
    strcat ( fname, ".cfg" );
    if ( drive[0] != '\0' || dir[0] != '\0' ) {
        sprintf ( path, "%s%s%s", drive, dir, fname );
    } else {
        _searchenv ( fname, "PATH", path );
    }
    lameopt[0] = '\0';

    if ( path[0] != '\0' ) {
        FILE* fp;
        if ( (fp = fopen ( path, "rt" )) != NULL ) {
            fgets ( lameopt, sizeof (lameopt)-1, fp );
            lameopt[sizeof (lameopt)-1] = '\0';
            if ( lameopt[0] != '\0' ) {
                char* p = (char *)(lameopt + strlen (lameopt) - 1);
                while ( p >= lameopt && (*p == 10 || *p == 13) ) *p-- = '\0';
            }
            fclose (fp);
        }
    }

    if ( lameopt[0] == '\0' ) {
        strcpy ( lameopt, DEFAULTCOMMAND );
    }

    if ( argv[1][0] != '/' && argv[1][0] != '-' ) {
        infile = argv[1];
        if ( argc > 2 && argv[2][0] != '/' && argv[2][0] != '-' ) {
            outfile = argv[2];
        }
    }

    if ( infile == NULL ) {
        for ( i = 1; i < argc; i++ ) {
            if ( argv[i][0] != '/' && argv[i][0] != '-' && !(argv[i-1][1] == 'f' || argv[i-1][1] == 'b' || argv[i-1][1] == 'v' ) ) {
                infile = argv[i];
                break;
            }
        }
    }
    if ( outfile == NULL ) {
        int f = 1;
        for ( i = 1; i < argc; i++ ) {
            if ( argv[i][0] != '/' && argv[i][0] != '-' && !(argv[i-1][1] == 'f' || argv[i-1][1] == 'b' || argv[i-1][1] == 'v' ) ) {
                if ( f-- == 0 ) {
                    outfile = argv[i];
                    break;
                }
            }
        }
    }

    sprintf ( param, "lame %s %s ", lameopt, infile );
    if ( outfile != NULL ) strcat ( param, outfile );
    fprintf ( stderr, "Calling lame with parameters: %s\n", param + 5 );
    return system ( param );
}
